<template>
	<v-row class="search-box">
		<v-col v-if="label" :cols="labelCols">
			<label for="" class="search-box-label">
				<v-icon x-small color="primary" class="mr-1">mdi-record-circle</v-icon>
				{{ label }}
			</label>
		</v-col>
		<v-col :cols="label ? textCols : ''">
			<v-select
				v-if="loadSelectBox"
				v-model="selectValue"
				:items="searchParam[parentPrgmId].evtCd1List"
				item-text="commCdNm"
				item-value="idx"
				solo
				outlined
				:hide-details="true"
				append-icon="mdi-chevron-down"
				class="v-select__custom"
			></v-select>
		</v-col>
	</v-row>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';
export default {
	props: {
		parentPrgmId: {
			type: String,
			require: true,
		},
		autoLoad: {
			type: Boolean,
			require: false,
			default: true,
		},
		label: {
			type: String,
			require: false,
			default: '대분류',
		},
		addAll: {
			type: Boolean,
			require: false,
			default: false,
		},
		textCols: {
			type: Number,
			require: false,
			default: 7,
		},
		labelCols: {
			type: Number,
			require: false,
			default: 4,
		},
	},
	data() {
		return {
			loadSelectBox: false,
		};
	},
	computed: {
		...mapState({
			searchParam: state => state.pageData,
		}),
		selectValue: {
			get() {
				return this.searchParam[this.parentPrgmId].evtCd1;
			},
			set(value) {
				return this.setPageData({ evtCd1: value });
			},
		},
	},
	async created() {
		if (this.autoLoad) {
			await this.initData();
		}
	},
	methods: {
		...mapMutations({ setPageData: 'setPageData' }),
		...mapActions({
			postApi: 'modules/list/postApi',
			postUpdateApi: 'modules/list/postUpdateApi',
			postApiReturn: 'modules/list/postApiReturn',
			setTree: 'modules/list/setTree',
			chkOpenTabList: 'chkOpenTabList',
		}),
		async initData() {
			this.loadSelectBox = false;
			var evtCd1List = await this.postApiReturn({
				apiKey: 'selectCommCd',
				resKey: 'commCdData',
				sendParam: {
					commGrpCd: 'EM_EVT1',
					useFg: '1',
				},
			});
			if (this.addAll) {
				evtCd1List.unshift({
					commCdNm: '전체',
					commCd: '',
				});
			}
			// evtCd1List.unshift({
			//   commCdNm: "전체"
			// });

			var tempIdx = 0;
			evtCd1List.map(item => {
				item.idx = tempIdx++;
			});

			this.setPageData({ evtCd1: 0, evtCd1List: evtCd1List });
			this.loadSelectBox = true;
		},
	},
};
</script>

<style></style>
